      subroutine gas
c
c     Utility program to compute miscellaneous gas dynamic properties
c
      implicit none

      integer mode,ist
      real    gamma,gascon
      character*80 version

      call pgmver(version)
      write(*,*) 'Version is: ', version

      ist   = 0
      gamma = 1.4
      gascon = 1716.
c
c     entry to program
  100 continue

      if ( ist .ne. 0 ) then
        write(6,*)
        write(6,*) 'press <cr> to continue'
        read(5,*) 
      end if
      ist = 1

c     Menu
      write(6,*) ' '
      write(6,*) 'Gas Dynamic Properties Program'
      write(6,*) '  0 - exit'
      write(6,*) '  1 - Reset Gamma and Gas Constant'
      write(6,*) '  2 - NACA 1135 (given M)'
      write(6,*) '  3 - M given A/A*'
      write(6,*) '  4 - 1976 Standard Atmosphere'
      write(6,*) '  8 - Mass Flow Rate'
      write(6,*) ' 11 - Viscous Properties (Re,Y+,etc)'
      write(6,*) ' 12 - Hammershock Speed and Overpressure'
      write(6,*) ' 13 - d(mdot)=f(dM,M,mdot)'
      write(6,*) ' 14 - Coefficient of Viscosity given Temperature'
      write(6,*) ' enter mode'
      read(5,*) mode

      if ( mode .eq. 0 ) then
        go to 500
      else if ( mode .eq. 1 ) then
        write(6,*) 'Old gamma:        ',gamma
        write(6,*) 'Old Gas Constant: ',gascon
        write(6,*) ' enter new gamma'
        read(5,*) gamma
        write(6,*) ' enter new gas constant'
        read(5,*) gascon
      else if ( mode .eq. 2 ) then
        call naca1135(gamma,gascon)
      else if ( mode .eq. 3 ) then
        call astar(gamma)
      else if ( mode .eq. 4 ) then
        call atmos
      else if ( mode .eq. 8 ) then
        call masmom(gamma,gascon)
      else if ( mode .eq. 11 ) then
        call visc(gamma,gascon)
      else if ( mode .eq. 12 ) then
        call hammer(gamma)
      else if ( mode .eq. 13 ) then
        call masmac(gamma)
      else if ( mode .eq. 14 ) then
        call visc_sutherland
      else
        write(6,*) 'Unrecognized mode'
      end if

c     go back to top
      go to 100

c     exit from program
  500 continue

      return
      end
