      SUBROUTINE masmom(gamma,gascon)
C     Calculates handy-dandy mass flow
C
C     ROUTINE TO COMPUTE MASS FLOW FROM FREESTREAM CONDITIONS AND
C     CAPTURE AREA
C
C     UNITS: P           -  PSIA
C            T           -  DEGREES R
C            AREA SQUARE -  INCHES
C            MASS FLOW   -  POUNDS MASS PER SECOND
C
  100 CONTINUE
      WRITE(6,*)
      WRITE(6,*) 'ASSUMED GAS:'
      WRITE(6,*) ' GAMMA = ',GAMMA
      WRITE(6,*) ' R     = ',GASCON
C
      WRITE(6,*)
      WRITE(6,*) ' 0 FINISHED'
      WRITE(6,*) ' 1 GIVE STATIC CONDITIONS'
      WRITE(6,*) ' 2 GIVE TOTAL CONDITIONS'
      WRITE(6,*) 'ENTER MODE '
      READ(5,*) IMOD
C
      IF(IMOD .EQ. 0) THEN
        RETURN
      ELSE IF(IMOD .EQ. 1) THEN
        WRITE(6,*) ' Enter Mach'
        READ(5,*) AMACH
        WRITE(6,*) ' Enter static pressure (psia)'
        READ(5,*) P
        WRITE(6,*) ' Enter static temperature (DEG R)'
        READ(5,*) T
        WRITE(6,*) ' Enter area (square inches)'
        READ(5,*) AREA
      ELSE IF(IMOD .EQ. 2) THEN
        WRITE(6,*) ' Enter Mach'
        READ(5,*) AMACH
        WRITE(6,*) ' Enter total pressure (psia)'
        READ(5,*) PT
        WRITE(6,*) ' Enter total temperature (DEG R)'
        READ(5,*) TT
        WRITE(6,*) ' Enter capture area (square inches)'
        READ(5,*) AREA
      END IF
C
      IF(IMOD .EQ. 2) THEN
        FM = 1.+.5*(GAMMA-1.)*AMACH*AMACH
        P  = PT*FM**(-GAMMA/(GAMMA-1.))
        T  = TT/FM
      END IF
C
      RHO = P*144./(GASCON*T)
      C   = SQRT(GAMMA*GASCON*T)
      U   = AMACH*C
      A1  = AREA/144.
C
      AMF = RHO*U*A1*32.2
C
      WRITE(6,*) 'MASS FLOW (POUNDS MASS)',AMF
      WRITE(6,*) '--------------------------------'
C
      GO TO 100
C
      END
