      subroutine cgns_list_bases ( CGNS_file_index, nbases )
c
c     routine to list the bases existing in a CGNS file
c
      implicit none
c
      include 'cgnslib_f.h'
c
      integer      CGNS_file_index
      integer      nbases
c
      integer      ier
      integer      nbase
      character*80 basename
      integer      cell_dim
      integer      phys_dim
c
      nbases = 0
c
      call cg_nbases_f ( CGNS_file_index, nbases, ier )
      if ( ier .ne. ALL_OK ) then
        write(6,*) 'error reading number of bases. ier: ',ier
        write(6,*) CGNS_file_index
        nbases = 0
        return
      end if
c
      write(6,*) 
      write(6,*) '  Bases in database:'
c
      do nbase=1,nbases
        call cg_base_read_f ( CGNS_file_index, nbase, basename,
     &                        cell_dim, phys_dim, ier )
        if ( ier .ne. ALL_OK ) then
          write(6,*) '  cgns_list_bases: error: reading base: '
     &               ,nbase
          return
        end if
c
        write(6,*) nbase,' - ',basename
c
      end do
c
      return
      end
