       subroutine create_working_file ( CGNS_file_index, wf_name )
c
c************************************************************************
c***                  Jeff Math, Bob Bush, Stephan Staudacher         ***
c***             Simulation and Modeling Group                        ***
c***      Aeromechanical, Chemical, and Fluid Systems                 ***
c***          United Technologies Research Center                     ***
c************************************************************************
c
      implicit none
c
      integer        CGNS_file_index   !mid-level lib file pointer
      character*80   wf_name
c
      integer        imode
      character*1    ans
      character      cfile*80
      integer        i,iclen
      integer        add_to_base
      integer        nbases
c
c     initialize
      imode = 0
      iclen = 0
      cfile = ' '
c
  100 continue
      write (6,*) ' Fill Working File Menu '
      write (6,*) ' 0 - return to main menu'
      write (6,*) ' 1 - read cgns format'
      write (6,*) ' 2 - read plot3d format'
      write (6,*) ' 3 - read Wind Common File Format'
      write (6,*) ' enter mode:'
      read (5,*) imode
c
      if ( imode .eq. 0 ) then
        go to 500
      else
c       read a file
c       get file name
        write(6,*)
     .     ' Enter file name to read (max. 80 characters, no spaces)'
        read (5,'(a80)') cfile
c
c       parse file name
        do 10 i=1,80
          if (cfile(i:i).eq.' ') then
             iclen = i - 1
             goto 11
          endif
   10   continue
        iclen = 80
   11   continue
c
c       determine if want to add a new base or add to a base
        call cgns_list_bases ( CGNS_file_index, nbases )
c
        if ( nbases .gt. 0 ) then
          write(6,*) '  Enter base to add info to (0=new base) '
          read(5,*) add_to_base
        else
          write(6,*) '  Filling the first base in the working file'
          add_to_base = 0
        end if
c
        if ( imode .eq. 1 ) then
c         cgns
          call read_cgns( CGNS_file_index,wf_name,cfile,iclen
     &                   ,add_to_base)
c
        else if ( imode .eq. 2 ) then
c         plot3d
          call setupplot3d(0, CGNS_file_index,cfile,iclen,add_to_base)
c
        else if ( imode .eq. 3 ) then
c         Wind Common File Format (cff)
          call cf_to_cgns(0, wf_name, CGNS_file_index, 
     &                    cfile,iclen,add_to_base)
c
        else
          write(6,*) ' unrecognized read mode'
        end if
      end if
c
c     go back to see if want to read more
      go to 100
c
  500 continue
      return
      end
