
       subroutine read_plot3d( CGNS_file_index, cfile , iclen, addfile)
c
       implicit none
c
c   read plot3d file format
c      (extracted write_cgns code is preceded by cgns)
c
c define attributes
       integer   CGNS_file_index
       character cfile*80
       integer iclen, addfile
c
       include 'commons.i'
cgns
       include 'cgnslib_f.h'
       integer unit_mass, unit_length, unit_time, unit_temperature
       integer unit_angle, dimension
       integer base_no, zone_no, coord_no, sol_no
       integer field_no, zonetype
       integer zone_dim(iidim*2)
       integer fiidim,figrdim,fzones,fsols,fcoords
       integer nzones, nbases
       integer startsol,startzone
       integer ioldsols,ioldzones,iwriteref
       integer sumcoords, sumsols, wzone
       integer cg, ier, zone, coord, i, sol, field, nsize, fn, imore
       integer iclen_cgns, data_class, unit
       integer ijkdim,istop
       integer j,k,cnt
       integer      ihole,location,ptset_type,nptsets,index_dimension
       character*32 holename
       integer, allocatable  :: pnts(:,:,:)
       real,    allocatable:: xyz(:)
       real,    allocatable:: values(:)
       double precision, allocatable:: Dxyz(:)
       double precision, allocatable:: Dvalues(:)
       character*32 zonename, solname, fieldname
       character*80 BaseName
       character*32 coordname(Ndim)
       character*32 fbasename
       character*39 frefstr,refstr
c
c   add cgns extension to file name
c
       write(*,*)'rwplot3d:cfile ',cfile
cst    
       iwriteref=0
       ioldsols=0
       ioldzones=0
       startzone=1
       startsol=1
       cfile_cgns = 'Tmp/tmp.cgns'
       iclen_cgns = 12
       zonetype=Structured
cgns

       coordname(1) = 'CoordinateX'
       coordname(2) = 'CoordinateY'
       coordname(3) = 'CoordinateZ'

cgns

c      default units
       unit_mass = Kilogram
       unit_length = Meter
       unit_time = Second
       unit_temperature = Kelvin
       unit_angle = Radian

       if (itype.eq.11.or.itype.eq.12.or.itype.eq.14.or.itype.eq.15.
     .                    or.itype.eq.17.or.itype.eq.18) then
           call user_data_class (data_class,unit)
       end if

! *** initialize
       ier = 0
! *** get size information Plot3d File
       nzones = 1
       if (imb.ne.1.and.istor.eq.1) read (iunit,*) nzones
       if (imb.ne.1.and.istor.ge.2) read (iunit  ) nzones
       if ( nzones .gt. nzonemax ) then
         write(6,*) '  read_plot3d: more zones than dimension in'
     &             ,' commons0.i'
         write(6,*) '    current dimension: ',nzonemax
         write(6,*) '      number of zones: ',nzones
         return
       end if
c       if (itype.eq.13) iidim=igrdim
c       if ((itype.eq.11).or.(itype.eq.12)) iidim=isoldim 

       if (addfile.eq.0) then
c    *** adding new base
c        define name
         cg = CGNS_file_index
         write ( BaseName,* ) 'Base from PLOT3D: ',trim(cfile)
         print *, '  adding base.  Name: ',trim(BaseName)
         write(6,*)'iidim',iidim
         write(6,*)'igrdim',igrdim
         call cg_base_write_f(cg, BaseName, iidim, igrdim, base_no, ier)
         if (ier .ne. 0) call cg_error_exit_f
c
       else
!    *** base
         cg = CGNS_file_index
         base_no = addfile
         call cg_nzones_f ( CGNS_file_index, base_no, fzones, ier )
         if (ier .ne. 0) call cg_error_exit_f
         if ((itype.eq.11).or.(itype.eq.12))then
           sumcoords=0
           do zone=1,fzones
             call cg_ncoords_f(cg,base_no,zone,fcoords,ier)  
             if (ier .ne. 0) call cg_error_exit_f
             write (6,*) 'Base ', base_no, ' Zone ', zone, ' contains ', 
     .       fcoords, ' Coordinates'
             sumcoords=fcoords+sumcoords
           enddo
           if ((sumcoords.eq.0).and.(fzones.eq.nzones))then
             write (6,*) 'Enter 1 to write Grid to Zones 1 to ',nzones
             read (5,*) ioldzones
             if (ioldzones.eq.1) then 
                startzone=1
             else
                startzone=fzones+1
             endif   
           endif
         elseif (itype.eq.13) then
           sumsols=0
           do zone=1,fzones
             call cg_nsols_f(cg,base_no,zone,fsols,ier)  
             if (ier .ne. 0) call cg_error_exit_f
             write (6,*) 'Base ', base_no, ' Zone ', zone, ' contains ', 
     .       fsols, ' Solutions'
             sumsols=fsols+sumsols
           enddo
           if (fzones.eq.nzones)then
             write (6,*) 'Enter 1 to append Solution to Zones 1 to ',
     .                    nzones
             read (5,*) ioldsols
             if (ioldsols.eq.1)then
               startzone=1
               startsol=sumsols/fzones+1
               write(6,*)'startsol',startsol
               write(6,*)'sumsols',sumsols
               write(6,*)'fzones',fzones
            else
               startzone=fzones+1
               startsol=1
             endif
           endif
         endif
       endif

c
c   initialize number of nodes and cells for less than 3 dimensions
c
       do 110 zone=1,nzones
       do 110 dimension=1,Ndim
          zone_dim0(dimension,zone) = 1
  110     zone_dim0(dimension+Ndim,zone) = 1
c
       if (istor.eq.1) read (iunit,*)
     .    ((zone_dim0(dimension,zone), dimension=1,iidim),
     .      zone=1,nzones)
       if (istor.ge.2) read (iunit  )
     .    ((zone_dim0(dimension,zone), dimension=1,iidim), 
     .      zone=1,nzones)
c
c   set number of cells - valid for node centered
c     (needed for cgns)
       do 120 zone=1,nzones
       do 120 dimension=1,iidim
  120   zone_dim0(dimension+Ndim,zone) = zone_dim0(dimension,zone)-1
c
c      check that this will fit with current dimensions
       istop = 0
       do zone = 1,nzones
         ijkdim = 1
         do dimension = 1,iidim
           ijkdim = ijkdim*zone_dim0(dimension,zone)
         end do
         if ( ijkdim .gt. nptsmax ) then
           istop = 1
           write(6,*) '  read_plot3d: zone ',zone,' is too big for'
     &               ,' current program dimensions in commons0.i'
           write(6,*) '    current dimension: ',nptsmax
           write(6,*) '    size of this zone: ',ijkdim
         end if
       end do
       if ( istop .ne. 0 ) return
c
c   data
cgns
! *** zone
c
       do 150 zone=1,nzones
          nsize = 1
c          write(6,*)'startzone',startzone
c          write(6,*)'zone ',zone
          zone_no=startzone+zone-1
          do 130 dimension=1,iidim
             zone_dim(dimension  ) = zone_dim0(dimension ,zone)
             zone_dim(dimension+iidim) = zone_dim0(dimension
     .            +Ndim,zone)
  130        nsize = nsize * zone_dim(dimension)
cgns  
          wzone=zone_no  
          if (wzone.lt.10)
     &          write(zonename,'(a5,i1)') 'zone#',wzone
          if ((wzone.ge.10).and.(wzone.lt.100))
     &          write(zonename,'(a5,i2)') 'zone#',wzone
          if (wzone.ge.100)
     &          write(zonename,'(a5,i3)') 'zone#',wzone
 
          write(6,*)'ioldsolds, ioldzones ', ioldsols, ioldzones 
          if((ioldsols.eq.0).and.(ioldzones.eq.0)) then
            call cg_zone_write_f(cg,base_no,zonename,zone_dim,zonetype,
     &          zone_no,ier)
              write(*,*) ' Reading zone ',zone
              write(*,*) ' writing zone_no ',zone_no
            if (ier .ne. 0) then
              write(*,*) 'cg_zone_write'
              write(*,*) 'iidim ',iidim
              write(*,*) 'zone_dim ',zone_dim
              write(*,*) 'zone_no ',zone_no
              write(*,*) 'base_no ',base_no
              call cg_error_exit_f
            endif
          endif

c      formatted, single precision, non-iblanked
c      formatted, single precision, iblanked
c      formatted, double precision, non-iblanked
c      formatted, double precision, iblanked
c      unformatted/binary, single precision, non-iblanked
c      unformatted/binary, single precision, iblanked
c      unformatted/binary, double precision, non-iblanked
c      unformatted/binary, double precision, iblanked
c
          if (itype.eq.11.or.itype.eq.12.or.itype.eq.14.or.itype.eq.15.
     .                    or.itype.eq.17.or.itype.eq.18) then
c
c   read grid
c
            if ( istor .eq. 1 ) then
c             formatted
              if ( iprec .eq. 1 ) then
                if ( iblnk .ne. 1 ) then
                  read(iunit,*) 
     &              (( xyz0(pos,coord), pos=1,nsize), coord=1,igrdim)
                else
                  read(iunit,*) 
     &              (( xyz0(pos,coord), pos=1,nsize), coord=1,igrdim),
     &              (iblank_real  (pos), pos=1,nsize)
                end if
              else if ( iprec .eq. 2 ) then
                if ( iblnk .ne. 1 ) then
                  read(iunit,*) 
     &              (( Dxyz0(pos,coord), pos=1,nsize), coord=1,igrdim)
                else
                  read(iunit,*) 
     &              (( Dxyz0(pos,coord), pos=1,nsize), coord=1,igrdim),
     &              (iblank_double  (pos), pos=1,nsize)
                end if
              else
                write(6,*) 'rplot3d: must be single or double precision'
                return
              end if
c
            else if ( istor .eq. 2 ) then
c             unformatted
              if ( iprec .eq. 1 ) then
                if ( iblnk .ne. 1 ) then
                  read(iunit  ) 
     &              (( xyz0(pos,coord), pos=1,nsize), coord=1,igrdim)
                else
                  read(iunit  ) 
     &              (( xyz0(pos,coord), pos=1,nsize), coord=1,igrdim),
     &              (iblank_real  (pos), pos=1,nsize)
                end if
              else if ( iprec .eq. 2 ) then
                if ( iblnk .ne. 1 ) then
                  read(iunit  ) 
     &              (( Dxyz0(pos,coord), pos=1,nsize), coord=1,igrdim)
                else
                  read(iunit  ) 
     &              (( Dxyz0(pos,coord), pos=1,nsize), coord=1,igrdim),
     &              (iblank_double  (pos), pos=1,nsize)
                end if
              else
                write(6,*) 'rplot3d: must be single or double precision'
                return
              end if
            else
c             bindary, but not implemented yet
              write(6,*) 'rplot3d: binary mode read not yet implemented'
              return
            endif
 
          endif     ! reading grid
c
c      formatted, single precision
c      formatted, double precision
c      unformatted/binary, single precision
c      unformatted/binary, double precision
c
          if (itype.ge.13.and.itype.le.15) then
c
c   read solution
c
             if (istor.eq.1) read (iunit,*) fsmach, alpha, re, runno
             if (istor.ge.2) read (iunit  ) fsmach, alpha, re, runno
c -----read header
             if (zone.eq.1) then
                write(6,'(/a27,2f8.3,e15.6,f8.3)')
     .           ' fsmach, alpha, re, runno =', fsmach, alpha, re, runno
                write(6,'(/a42)')
     .                      ' are these correct?  1 for yes, else non-1'
                read (5,*) imore
                if (imore.ne.1) then
                   write(6,'(/a39)')
     .                         ' enter correct fsmach, alpha, re, runno'
                   read (5,*) fsmach, alpha, re, runno
                endif
                write(refstr,'(2f8.3,e15.6,f8.3)') fsmach,
     .                   alpha, re, runno
                call cg_goto_f(cg, base_no,ier,'end')
                if (ier .ne. 0) call cg_error_exit_f
                if (addfile.eq.0) then
                  call cg_state_write_f(refstr,ier)
                  if (ier .ne. 0) call cg_error_exit_f
                else
                  call cg_state_read_f(frefstr,ier)
                  if (ier.eq.2) then
                    ier=0
                    call cg_goto_f(cg,base_no,ier,'Zone_t',
     .                            zone_no,'end')
                    if (ier.ne.0) call cg_error_exit_f
                    call cg_state_read_f(frefstr,ier)
                    if (ier.eq.2) then
                      ier=0
                      call cg_goto_f(cg,base_no,ier,'end')
                      if (ier.ne.0) call cg_error_exit_f
                      call cg_state_write_f(refstr,ier)
                      if (ier .ne. 0) call cg_error_exit_f
                    elseif (ier.ne.0) then 
                      call cg_error_exit_f
                    elseif (frefstr.ne.refstr) then
                      write(6,*)'Referencepoint incompatible, Read to ',
     .                     'Zone ',startzone,' to ',startzone+nzones,
     .                     'not possible'
                      return
                    endif
                  elseif (ier .ne. 0) then
                    call cg_error_exit_f
                  elseif (frefstr.ne.refstr) then
                    call cg_goto_f(cg,base_no,ier,'Zone_t',
     .                             zone_no,'end')
                    if (ier.ne.0) call cg_error_exit_f
                    call cg_state_read_f(frefstr,ier)
                    if (ier.eq.2) then
                      ier=0
                      iwriteref=1
                    elseif (ier.ne.0) then 
                      call cg_error_exit_f
                    elseif (frefstr.ne.refstr) then
                      write(6,*)'Referencepoint incompatible, Read to '
     .                     ,'Zone ',startzone,' to ',startzone+nzones,
     .                     'not possible'
                      return
                    endif
                  endif   
                endif
             endif
c
             if (istor.eq.1.and.iprec.eq.1) read (iunit,*)
     .             (( values0(pos,field), pos=1,nsize), field=1,isoldim)
             if (istor.eq.1.and.iprec.eq.2) read (iunit,*)
     .             ((Dvalues0(pos,field), pos=1,nsize), field=1,isoldim)
             if (istor.ge.2.and.iprec.eq.1) read (iunit  )
     .             (( values0(pos,field), pos=1,nsize), field=1,isoldim)
             if (istor.ge.2.and.iprec.eq.2) read (iunit  )
     .             ((Dvalues0(pos,field), pos=1,nsize), field=1,isoldim)
          endif
c
c   write single-precision grid
c
          if ((itype.eq.11.or.itype.eq.12.or.itype.eq.14.or.itype.eq.15.
     .      or.itype.eq.17.or.itype.eq.18).and.iprec.eq.1) then
cgns
! *** coordinate
             allocate (xyz (1:nsize))
             do coord=1,igrdim
                do pos=1,nsize
                   xyz(pos) = xyz0(pos,coord)
                enddo
cst                coord_no=coord
                call cg_coord_write_f(cg, base_no, zone_no, RealSingle,
     .                           coordname(coord), xyz, coord_no, ier)
                if (ier .ne. 0) then
                    write (*,*)'cg_coord_write'
                    write (*,*)'size(xyz) ',size(xyz)
                    write (*,*)'coord_no ',coord_no
                    write (*,*)'base_no ',base_no
                    write (*,*)'zone_no ',zone_no
                    call cg_error_exit_f
                end if
! ** GOTO
	        call cg_goto_f(cg, base_no, ier, 'Zone_t', zone,
     &                           'GridCoordinates_t', 1,
     &                           'DataArray_t', coord, 'end')
                if (ier .ne. 0) then
                   write(*,*) 'cg_goto_f'
                    call cg_error_exit_f
                end if
! ** variable data attributes:
                call cg_dataclass_write_f (data_class, ier)
                if (ier .ne. 0) call cg_error_exit_f
                if (unit.ne.0) then
                  call cg_units_write_f ( unit_mass, unit_length,
     &               unit_time,unit_temperature,unit_angle, ier)
                  write (6,*) "Mass, Time, Temperature, Angle Units ", 
     &                "set to default =  SI Units"
                  if (ier .ne. 0) call cg_error_exit_f
                end if

             enddo
             deallocate(xyz)
c
c   write double-precision grid
c
          elseif ((itype.eq.11.or.itype.eq.12.or.itype.eq.14.or.itype.eq
     .      .15.or.itype.eq.17.or.itype.eq.18).and.iprec.eq.2) then
cgns
! *** coordinate
             allocate (Dxyz (1:nsize))
             do coord=1,igrdim
                do pos=1,nsize
                   Dxyz(pos) = Dxyz0(pos,coord)
                enddo
                call cg_coord_write_f(cg, base_no, zone_no, RealDouble,
     .                           coordname(coord), Dxyz, coord_no, ier)
                if (ier .ne. 0) call cg_error_exit_f

! ** GOTO
	        call cg_goto_f(cg, base_no, ier, 'Zone_t', zone,
     &                           'GridCoordinates_t', 1,
     &                           'DataArray_t', coord, 'end')
                if (ier .ne. 0) call cg_error_exit_f

! ** variable data attributes:
                call cg_dataclass_write_f (data_class, ier)
                if (ier .ne. 0) call cg_error_exit_f
                if (unit.ne.0) then
                  call cg_units_write_f ( unit_mass, unit_length,
     &               unit_time,unit_temperature,unit_angle, ier)
                  write (6,*) "Mass, Time, Temperature, Angle Units ", 
     &                "set to default =  SI Units"
                  if (ier .ne. 0) call cg_error_exit_f
                end if

             enddo
             deallocate(Dxyz)
c
          endif
c
c   write iblank
          if ( iblnk .eq. 1 ) then
            if ( itype.eq.11 .or. itype.eq.12 .or. itype.eq.14 .or.
     &           itype.eq.15 .or. itype.eq.17 .or. itype.eq.18 ) then
c
              if ( iprec .eq. 1 ) then
                cnt = count ( iblank_real .ne. 1 ) 
              else if ( iprec .eq. 2 ) then
                cnt = count ( iblank_double .ne. 1 ) 
              end if
              nptsets = 1
c
c             warning: only valid for 3d datasets for now...
              index_dimension = 3
              allocate ( pnts ( index_dimension, cnt, nptsets ) )
c
c             decode iblank into OversetHole data
c             assume that all iblank points in a zone are collected 
c                    into a single hole
              pos = 0
              cnt = 0
              do i = 1,zone_dim0(1,zone)
                do j = 1,zone_dim0(2,zone)
                  do k = 1,zone_dim0(3,zone)
                    pos = pos+1
                    ihole = 0
                    if ( iprec .eq. 1 ) then
                      if ( iblank_real(pos) .ne. 1 ) ihole = 1
                    else if ( iprec .eq. 2 ) then
                      if ( iblank_double(pos) .ne. 1 ) ihole = 1
                    end if
                    if ( ihole .eq. 1 ) then
                      cnt = cnt+1
                      pnts(1,cnt,1) = i
                      pnts(2,cnt,1) = j
                      pnts(3,cnt,1) = k
                    end if
                  end do
                end do
              end do
              if ( cnt .gt. 0 ) then
                ihole = 1
                holename = 'p3d iblank holes'
                location = Vertex
                ptset_type = PointList
                call cg_hole_write_f ( cg, base_no,zone,holename,
     &                                 location,ptset_type,nptsets,
     &                                 cnt,pnts,ihole,ier)
                if ( ier .ne. ALL_OK ) call cg_error_exit_f
              end if
              deallocate ( pnts )
            end if
          end if
c
c   write solution
c
          if (itype.ge.13.and.itype.le.15) then

             sol_no = startsol

cgns
! *** solution
             if (sol_no.lt.10)
     &           write(solname,'(a5,i1)') ' sol#',sol_no
             if ((sol_no.lt.100).and.(sol_no.ge.10))
     &           write(solname,'(a5,i2)') ' sol#',sol_no
             if (sol_no.ge.100)
     &           write(solname,'(a5,i3)') ' sol#',sol_no
             write(6,*)'Writing SOLUTION'
	     write(6,*)'solname ',solname
	     call cg_goto_f(cg, base_no, ier, 'Zone_t', zone_no,
     &                           'end')
             if (ier .ne. 0) call cg_error_exit_f
             call cg_sol_write_f(cg, base_no, zone_no, solname,
     &                           Vertex, sol_no, ier)
             if (ier .ne. 0) call cg_error_exit_f
              write(6,*)'Returnvalue sol_no ',sol_no

             if (iwriteref.eq.1) then
	        call cg_goto_f(cg, base_no, ier, 'Zone_t', zone_no,
     &                           'end')
                if (ier .ne. 0) call cg_error_exit_f
                call cg_state_write_f(refstr,ier)
                if (ier .ne. 0) call cg_error_exit_f
	        call cg_goto_f(cg, base_no, ier, 'Zone_t', zone_no,
     &                         'FlowSolution_t',sol_no,'end')
                if (ier .ne. 0) call cg_error_exit_f
                             endif

             do 140 field=1,isoldim
! *** solution field
                fieldname = ' '
                if (field.eq.1) write(fieldname,'(a7)') 'Density'
                if (field.eq.2) write(fieldname,'(a9)') 'MomentumX'
                if (field.eq.3) write(fieldname,'(a9)') 'MomentumY'
                if (field.eq.4.and.isoldim.eq.5)
     .             write(fieldname,'(a9)') 'MomentumZ'
                if (field.eq.4.and.isoldim.eq.4)
     .             write(fieldname,'(a23)') 'EnergyStagnationDensity'
                if (field.eq.5.and.isoldim.eq.5)
     .             write(fieldname,'(a23)') 'EnergyStagnationDensity'

                if (iprec.eq.1) then
                   allocate (values (1:nsize))
                   do pos=1,nsize
                       values(pos) =  values0(pos,field)
                   enddo
                   call cg_field_write_f(cg, base_no, zone_no, sol_no,
     &                RealSingle, fieldname,  values, field_no, ier)
                   deallocate(values)
                else
                   allocate (Dvalues (1:nsize))
                   do pos=1,nsize
                      Dvalues(pos) = Dvalues0(pos,field)
                   enddo
                   call cg_field_write_f(cg, base_no, zone_no, sol_no,
     &                RealDouble, fieldname, Dvalues, field_no, ier)
                   deallocate(Dvalues)
                endif
                if (ier .ne. 0) call cg_error_exit_f
! ** GOTO
  	        call cg_goto_f(cg, base_no, ier, 'Zone_t', zone_no,
     &                           'FlowSolution_t', sol_no,
     &                           'DataArray_t',field_no,'end')
                if (ier .ne. 0) call cg_error_exit_f

! ** variable data attributes:
                call cg_dataclass_write_f(
     &               NormalizedByUnknownDimensional, ier)
                if (ier .ne. 0) call cg_error_exit_f
c


  140        continue ! Loop solutions
c
          endif !Solution 
c
  150  continue
c
       return
       end
c
c-----------------------------------------------------------------------




