!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	subroutine read_coord_as_real(cg, base, zone, nsize, zone_dim, 
     &                                 x_real,
     &                                 y_real, z_real)
        implicit none
	include 'cgnslib_f.h'
c

	integer cg, base, zone, zone_dim(3),nsize
	real*4 x_real(nsize)
	real*4 y_real(nsize) 
	real*4 z_real(nsize)
! local
        integer rmin(3)
	integer ier, i, k, j, num

        do i=1, 3
            rmin(i)=1
        enddo
! X:
        call cg_coord_read_f(cg, base, zone, 'CoordinateX', 
     &		RealSingle, rmin, zone_dim, x_real, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
! Y:
        call cg_coord_read_f(cg, base, zone, 'CoordinateY', 
     &		RealSingle, rmin, zone_dim, y_real, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
! Z:
        call cg_coord_read_f(cg, base, zone, 'CoordinateZ', 
     &		RealSingle, rmin, zone_dim, z_real, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

c       write(6,*) 'SINGLE zonedim',zone_dim,nsize
c       do k=1, zone_dim(3)
c       do j=1, zone_dim(2)
c       do i=1, zone_dim(1)
c           num=(k-1)*zone_dim(2)*zone_dim(1)+(j-1)*zone_dim(1)+i
c           write(6,'(3(a1,i1),a1,3(a3,f25.17))') '(',i,',',j,',',k,')',
c     &               				  ' x=',x_real(num),
c     &               				  ' y=',y_real(num),
c     &               				  ' z=',z_real(num)
c       enddo
c       enddo
c       enddo
        return

	end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

        subroutine read_coord_as_double(cg, base, zone, nsize,
     &                            zone_dim, 
     &                            x_double,y_double, z_double)
        implicit none
        include 'cgnslib_f.h'
c

        integer cg, base, zone, zone_dim(3), nsize
        double precision x_double(nsize)
        double precision y_double(nsize)
        double precision z_double(nsize)
        integer rmin(3)
        integer ier, i,j,k, num

        do i=1, 3
            rmin(i)=1
        enddo

! X:
        call cg_coord_read_f(cg, base, zone, 'CoordinateX', 
     &		RealDouble, rmin, zone_dim, x_double, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
! Y:
        call cg_coord_read_f(cg, base, zone, 'CoordinateY', 
     &		RealDouble, rmin, zone_dim, y_double, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
! Z:
        call cg_coord_read_f(cg, base, zone, 'CoordinateZ', 
     &     	RealDouble, rmin, zone_dim, z_double, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

c       write(6,*) 'DOUBLE'
c       do k=1, zone_dim(3)
c       do j=1, zone_dim(2)
c       do i=1, zone_dim(1)
c           num=(k-1)*zone_dim(2)*zone_dim(1)+(j-1)*zone_dim(1)+i
c           write(6,'(3(a1,i1),a1,3(a3,f25.17))') '(',i,',',j,',',k,')',
c     &               				  ' x=',x_double(num),
c     &               				  ' y=',y_double(num),
c     &               				  ' z=',z_double(num)
c       enddo
c       enddo
c       enddo

        return
        end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

cjam    subroutine read_field(cg, base, zone, sol, zone_dim, fieldname)
        subroutine read_field(cg, base, zone, sol, zone_dim, fieldname,
     .                                          rval, dval,nsize,iprec)
        implicit none
        include 'cgnslib_f.h'
cjam
c        include 'commons.i'
c

        integer cg, base, zone, sol, zone_dim(3), nsize,iprec
	character*(*) fieldname
! local variables:
	double precision dval(nsize)
        integer rmin(3), rmax(3)
        integer i, idim, jdim, j, k, pos, ier
cjam
        real*4 rval(nsize)
        integer ival(nsize)
c        write (6,*)'nsize',nsize
        do i=1, 3
            rmin(i)=1
	    rmax(i)=zone_dim(i)
c            write(6,*)'rmin',rmin(i)
c            write(6,*)'rmax',rmax(i)

        enddo

	idim = rmax(1)-rmin(1)+1
	jdim = rmax(2)-rmin(2)+1

! D O U B L E
cjam
       if (iprec.ne.1) then
c
        call cg_field_read_f(cg, base, zone, sol, fieldname,
     &                     RealDouble, rmin, rmax, dval, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

c       do k=rmin(3), rmax(3)
c         do j=rmin(2), rmax(2)
c           do i=rmin(1), rmax(1)
c		pos = i + idim*(j-1) + idim*jdim*(k-1)
c               write(6,'(3(a1,i1),a1,a8,f25.17)') 
c     &               '(',i,',',j,',',k,')', ' dval=',dval(pos)
c           enddo
c         enddo
c       enddo

! S I N G L E
cjam
       elseif (iprec.eq.1) then
c
        call cg_field_read_f(cg, base, zone, sol, fieldname,
     &                     RealSingle, rmin, rmax, rval, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
c
!	write(6,*) 'SINGLE'
c
c       do k=rmin(3), rmax(3)
c         do j=rmin(2), rmax(2)
c           do i=rmin(1), rmax(1)
c               pos = i + idim*(j-1) + idim*jdim*(k-1)
c               write(6,'(3(a1,i1),a1,a8,f25.17)')
c     &                '(',i,',',j,',',k,')', ' rval=',rval(pos)
c           enddo
c         enddo
c       enddo

! I N T E G E R
!	call cg_field_read_f(cg, base, zone, sol, fieldname,
!    &                     Integer, rmin, rmax, ival, ier)
!	if (ier .eq. ERROR) call cg_error_exit_f

!       write(6,*) 'INTEGER'

c       do k=rmin(3), rmax(3)
c         do j=rmin(2), rmax(2)
c           do i=rmin(1), rmax(1)
c               pos = i + idim*(j-1) + idim*jdim*(k-1)
c               write(6,'(3(a1,i1),a1,a8,i10)')
c     &                '(',i,',',j,',',k,')', ' ival=',ival(pos)
c           enddo
c         enddo
c       enddo
cjam
       endif
c

        return
        end











